# Асинхронный Чат  ✉️

Асинхронный час на базе raw-протоколов. Написан с помощью библиотеке ``asyncio`` и ``pywebio``

Так же в файле ``example.py`` есть приблизительный пример работы чата, с точки зрения взаимодействия raw-протоколов.
Неудобная система одновременного запуска python-файлов для общения. Уязвимость данного чата, возможность запустить - reverse-shell. 
Привело к идее, усовершенствовать данный чат. Асинхронными потоками/Асинхронный ввод-вывод, и веб страницей для удобства общения нескольких людей одновременно.

Чат имеет веб страницу. Окно чата. Возможность за логинится. Выполнен в стиле цитат известного стримера - ```Arthas```

### Доступ 🔑
#### Локальная сеть
Для возможности воспользоваться чатом в локальной сети, Вы должны использовать следующие команды:
```
git clone http://gogs.tomtit.tomsk.ru:3000/gr703_mimal/asynchronous_chat.git
cd asynchronous_chat && python3 chat.py
```

Далее у вас будет запущен чат по вашему локальному адресу и порту 8078, пример:
```
http://192.168.0.72:8078/
```

#### Открытая сеть
Для этого Вам понадобиться следующее ПО: ``https://dashboard.ngrok.com/get-started/setup``

Выполнить ряд команд для бесплатного хостинга:
```
unzip /path/to/ngrok.zip
ngrok config add-authtoken <YOU_TOKEN>
ngrok http 8078
```

